MODULE Rectangle EXPORTS Rectangle;

(* Implementierung der Rectangle Klasse.
Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 09.01.2001
*)

IMPORT PointO;

REVEAL
  T = Public BRANDED OBJECT	(* Objekt wird aufgedeckt und Redefiniert *)
        origin : PointO.T;
        corner : PointO.T;
      OVERRIDES			(* Redefinitionen *)
        setOrigin := SetOrigin;
        getOrigin := GetOrigin;
        setCorner := SetCorner;
        getCorner := GetCorner;
        area := Area;
        height := Height;
        moveTo := MoveTo;
        contains := Contains;
        asText := AsText;
      END;

PROCEDURE AsText(self : T) : TEXT =
(* Ausgabe der Werte als TEXT *)
BEGIN
  RETURN ("Rect origin: " & self.origin.asText() &
              " corner: " & self.corner.asText());
END AsText;

PROCEDURE GetOrigin(self : T): PointO.T =
(* Gibt den Wert von Origin zurck *)
BEGIN
  RETURN self.origin;
END GetOrigin;

PROCEDURE GetCorner(self : T): PointO.T =
(* Gibt den Wert von Corner zurck *)
BEGIN
  RETURN self.corner;
END GetCorner;

PROCEDURE SetOrigin(self: T; value : PointO.T) =
(* Setzt den Wert von Origin *)
BEGIN
  self.origin := value;
END SetOrigin;

PROCEDURE SetCorner(self: T; value : PointO.T) =
(* Setzt den Wert von Corner *)
BEGIN
  self.corner := value;
END SetCorner;

PROCEDURE Height (self: T) : INTEGER =
(* liefert die Hhe zurck, allso die differentz von corner und origin *)
BEGIN
  RETURN (self.corner.getX() - self.origin.getX());
END Height;

PROCEDURE Area (self: T) : INTEGER =
(* liefert die Flaeche zurck *)
BEGIN
  RETURN self.height() * 20;
END Area;

PROCEDURE MoveTo (self : T; p : PointO.T)=
(* Bewegt das rechteck T zum punkt p *)
VAR newPoint := NEW(PointO.T);
BEGIN
  newPoint := self.getCorner();
  self.setCorner(newPoint.add(p));

  newPoint := self.getOrigin();
  self.setOrigin(newPoint.add(p));
END MoveTo;

PROCEDURE Contains (self : T; p : PointO.T): BOOLEAN =
BEGIN
  RETURN TRUE;
END Contains;

BEGIN
END Rectangle.
