INTERFACE OrdnerADT;
(* Implementierung des ADTs Ordner, mit durch Zusicherungen geschtzen Funktionen
Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 11.01.2001
*)

IMPORT Assertion AS As;

TYPE Ordner <: REFANY;

PROCEDURE LegeTextAb     (VAR o: Ordner; t : TEXT) RAISES {As.Violated};
(* Legt einen Text ab, ist der Ordner bereits voll kommt es zur EXCEPTION As.Violated *)

PROCEDURE EntnehmeText   (VAR o: Ordner): TEXT RAISES {As.Violated};
(* Entnimmt einen Text aus dem Ordner o, ist dieser bereits leer wird As.Violated ausgelst *)

(* Mit den beiden folgenden funktionen knnen vor- und nachbedingung formuliert werden *)
PROCEDURE IstVoll        (    o: Ordner): BOOLEAN;
PROCEDURE IstLeer        (    o: Ordner): BOOLEAN;


PROCEDURE Beschrifte     (VAR o: Ordner; t : TEXT);
(* Legt den Titel des Ordners fest *)

PROCEDURE GibBeschriftung(    o: Ordner): TEXT;
(* gibt den Titel eines Ordners zurck *)

PROCEDURE Anlegen        ( ) : Ordner RAISES {As.Violated};
(* erzeugt einen neuen Ordner *)

END OrdnerADT.