INTERFACE CD;

(* Schnittstelle des abstrakten Datentyps CD.
   Autor           : Thomas von der Maen, RWTH Aachen
   Umgebung        : PM-3 Windows 2000
   Erstellt        : 19.12.00  Letzte Aenderung: 02.01.01 
*)

IMPORT Track;   (* Importiere den ADT Track *)

TYPE T <: REFANY;

PROCEDURE GetInterpret(cd: T): TEXT;
(* Liefert den Interpreten einer CD *)

PROCEDURE SetInterpret(VAR cd: T; interpret: TEXT);
(* Setzt den Interpreten der angegebenen CD *)

PROCEDURE GetTitle(cd: T): TEXT;
(* Liefert den Titel der bergebenen CD *)

PROCEDURE SetTitle(VAR cd: T; title: TEXT);
(* Setzt den Titel der bergebenen CD *)

PROCEDURE GetTotalTime(cd: T): CARDINAL;
(* Liefert die Gesamtspielzeit der CD in Sekunden *)

PROCEDURE AddTrack(VAR cd: T; track: Track.T);
(* Fgt einen Track der bergebenen CD hinzu *)

PROCEDURE RemoveTrack(VAR cd: T);
(* Lscht den letzten Track der bergebenen CD *)

PROCEDURE GetTrackCount(cd: T): CARDINAL;
(* Liefert die Anzahl der Tracks der bergebenen CD *)

PROCEDURE PrintTracklist(cd: T);
(* Zeigt die Trackliste der CD auf dem Bildschirm an *)

PROCEDURE CreateCD(): T;
(* Erstellt eine neue CD und initalisiert diese *)

END CD.