INTERFACE Diskographie;

(* Schnittstelle des Objektmoduls zur Verwaltung einer Diskographie.
   Autor           : Thomas von der Maen, RWTH Aachen
   Umgebung        : PM-3 Windows 2000
   Erstellt        : 19.12.00  Letzte Aenderung: 02.01.01 
*)

IMPORT CD;  (* Importiere den ADT CD *)

PROCEDURE Init();
(* Initialisiert die Diskographie. Diese enthlt dann keine CDs *)

PROCEDURE AddCD(cd: CD.T);
(* Fgt die bergebene CD der Diskographie hinzu *)

PROCEDURE GetCD(index: CARDINAL): CD.T;
(* Liefert die CD der Diskographie mit dem bergebenen Index *)

PROCEDURE RemoveCD(pos: CARDINAL);
(* Lscht die CD an der bergebenen Indexposition *)

PROCEDURE IsFull(): BOOLEAN;
(* Prft, ob die Diskographie voll ist *)

PROCEDURE IsEmpty(): BOOLEAN;
(* Prft, ob die Diskographie leer ist *)

PROCEDURE Print();
(* Listet den Inhalt der Diskographie auf dem Bildschirm *)

PROCEDURE PrintWithTracklist(); 
(* Listet den Inhalt der Diskographie inklusive der Trackliste jeder CD auf dem Bildschirm *)

END Diskographie.