INTERFACE Diskographie;

(* Interface zur Klasse Diskographie
   Autor          : Antje Nowack, Thomas van der Massen
   Umgebung : PM-3 Windows 95
   Erstellt        : 19.12.00  Letzte Aenderung: 22.01.01 
*)

IMPORT Tontraeger;
IMPORT CD; 
IMPORT Schallplatte;
IMPORT Kassette;

TYPE TontraegerTypen = {CDTyp, SchallplatteTyp, KassetteTyp};

TYPE T <: Public;
   Public = ROOT OBJECT
              METHODS
                AddCD(cd: CD.T);
                (* Fgt die bergebene CD der Diskographie hinzu *)

                 AddSchallplatte(schp: Schallplatte.T);
                (* Fgt die bergebene CD der Diskographie hinzu *)

                 AddKassette(kassette: Kassette.T);
                (* Fgt die bergebene CD der Diskographie hinzu *)

                GetTt(index: CARDINAL): Tontraeger.T;
                (* Liefert den Tontraeger der Diskographie mit dem bergebenen Index *)

                RemoveTt(pos: CARDINAL;);
                (* Lscht die CD an der bergebenen Indexposition *)


                IsFull(): BOOLEAN;
                (* Prft, ob die Diskographie voll ist *)

                IsEmpty(): BOOLEAN;
                (* Prft, ob die Diskographie leer ist *)

                Print();
                (* Listet den Inhalt der Diskographie auf dem Bildschirm *)

                PrintWithTracklist(); 
                (* Listet den Inhalt der Diskographie inklusive der Trackliste jeder CD auf dem Bildschirm *)
              
                TypAnStelle(i : CARDINAL) : TontraegerTypen;
                (* Liefert den Typ des Tontraegers an der i-ten Stelle *)

                TontraegerAnStelle(i : CARDINAL): Tontraeger.T;
                (* Liefert den Tontraeger an der i-ten Stelle. *)

         END;

END Diskographie.
