MODULE Kugel EXPORTS Main;

(* 
   Diese Programme berechnet rein funktional
   das Volumen einer Kugel.

   Autor           : Moritz Schnizler, RWTH Aachen
   Umgebung        : PM 3, Windows NT 4.0
   Erstellt        : 14.11.00
   Letzte Aenderung: 14.11.00
*)


IMPORT SIO; (* Importiere notwendige Ein-/Ausgabeoperationen *)


(* Folgende Funktionen ergeben sich aus dem Funktionsnetz. *)

PROCEDURE Ident(a: REAL): REAL =
BEGIN
  RETURN a;
END Ident;

PROCEDURE Const2(a: REAL): REAL =
BEGIN
  RETURN 2.0;
END Const2;

PROCEDURE Const3(a: REAL): REAL =
BEGIN
  RETURN 3.0;
END Const3;

PROCEDURE Const4(a: REAL): REAL =
BEGIN
  RETURN 4.0;
END Const4;

PROCEDURE ConstPi(a: REAL): REAL =
BEGIN
  RETURN 3.14159265;
END ConstPi;

PROCEDURE Division(a, b: REAL): REAL =
BEGIN
  RETURN a / b;
END Division;

PROCEDURE Mult(a, b: REAL): REAL =
BEGIN
  RETURN a * b;
END Mult;

PROCEDURE Quadrat(a: REAL): REAL =
BEGIN
  RETURN a * a;
END Quadrat;


(* Folgende Funktionen sind notwendig, da Modula-3 keine
   Konstruktion von Funktionsausdruecken unterstuetzt. *)

PROCEDURE Kubik(r: REAL): REAL =
(* Implementiert Ausdruck: [Ident, Quadrat] o Mult *)
BEGIN
  RETURN Mult(Ident(r), Quadrat(r));
END Kubik;

PROCEDURE MalPi(a: REAL): REAL =
(* Implementiert Ausdruck: [Ident, ConstPi] o Mult *)
BEGIN
  RETURN Mult(Ident(a), ConstPi(a));
END MalPi;

PROCEDURE MalVierDrittel(a: REAL): REAL =
(* Implementiert Ausdruck: [[Const4, Const3] o Div, Ident] o Mult *) 
BEGIN
  RETURN Mult(Division(Const4(a), Const3(a)), Ident(a));
END MalVierDrittel;


PROCEDURE Kugelvolumen(d: REAL): REAL =
(* Berechnet das Kugelvolumen fuer gegebenen Durchmesser d *)
BEGIN
  RETURN MalVierDrittel(MalPi(Kubik(Division(Ident(d), Const2(d)))));
END Kugelvolumen;

BEGIN
  SIO.PutText("Geben Sie den Kugeldurchmesser (in cm) ein: ");
  SIO.PutReal(Kugelvolumen(SIO.GetReal()));
  SIO.PutLine(" ccm betraegt das Kugelvolumen.");
END Kugel.
