MODULE Potenz EXPORTS Main;

(* Berechnet b hoch n nach Eingabe von b und n
   Autor: Antje Nowack, Moritz Schnizler
   Umgebung: PM3, Windows NT 4.0
   Erstellt: 22. 11. 2000
   Letzte Aenderung: 15.12.2000
*)

IMPORT SIO;


PROCEDURE EMPotenz(b: REAL; n: CARDINAL) : REAL =
(* Berechnet b hoch n iterativ durch einfache Multiplikation *)
VAR ergebnis: REAL := 1.0;

BEGIN
  FOR i := 1 TO n DO
    ergebnis := ergebnis * b;
  END;

  RETURN ergebnis;
END EMPotenz;


PROCEDURE SQPotenz(b: REAL; n: CARDINAL) : REAL =
(* Die Funktion gibt b hoch n bei gegebenen Parametern
   b und n zurueck, wobei das Ergebnis durch sukzessive
   Quadratbildung ermittelt wird.
   Idee: 
     (b hoch (n / 2)) = b hoch n fuer gerades n
     (b * b hoch (n - 1)) fuer ungerades n            *)
VAR rekErgebnis: REAL;

BEGIN
  IF n = 0 THEN 
    RETURN 1.0;
  ELSIF n MOD 2 = 0 THEN
    (* Rekursion fuer gerades n *)
    rekErgebnis := SQPotenz(b, n DIV 2);
    RETURN rekErgebnis * rekErgebnis;
  ELSE
    (* Rekursion fuer ungerades n *)
    RETURN b * SQPotenz(b, n - 1);
  END;
END SQPotenz;


VAR b        : REAL;
    n        : CARDINAL;
    restzeile: TEXT;

BEGIN 
  SIO.PutText("Geben Sie die Basis ein: ");
  b := SIO.GetReal();
  restzeile := SIO.GetLine();

  SIO.PutText("Geben Sie den Exponenten ein: ");
  n := SIO.GetInt();
  restzeile := SIO.GetLine();

  SIO.PutText("Das Ergebnis mit einfacher Multiplikation lautet: ");
  SIO.PutReal( EMPotenz(b, n) );
  SIO.Nl();

  SIO.PutText("Das Ergebnis mit sukzessiver Quadratbildung lautet: ");
  SIO.PutReal( SQPotenz(b, n) );
  SIO.Nl();
END Potenz.